Welcome to XC Calc

XConnect is Sutron Corporation's latest data collection, data processing and data storage software. Built on the strong principles of PcBase2, XConnect is compliant with today's 32-bit Windows operating systems and provides new tools and options for the user.

XConnect is a collection of executables designed to provide a complete solution for data collection, data handling, data viewing and data storage.

The role of XC Calc within an XConnect data collection system is to provide a flexible real-time general purpose, multi-value calculator. XC Calc connects automatically to a local or remote XConnect servers. XC Calc will connect to XC Decode and/or XC Rtu to receive data.

The user has full control over what sensors he/she would like to retrieve as the source values and the sensor to store the result. These functions include most common mathematical calculations and rating tables.

XCCalc yields the CPU time to most time critical task by doing all the calculation and database updates in the background.

Copyright © 2003 - 2006 Sutron Corporation. All rights reserved.


Moving around XC Calc

Moving around in XC Calc

The XC Calc application consists of these main areas:

  • The Menu Bar provides access to all user-controllable functions within the application.

  • The Toolbar provides one-click access to important functions.

  • The Status panel provides the user with informational or error messages related to data display.

Click an area on the image below for more information.


Creating a simple poll group

Follow these steps to create a simple calculation poll group.

  1. Click the XC Calc icon on the desktop. The XC Calc application starts.

  2. From the Options menu, select Edit Setup Parameters or from the toolbar click on the [image] icon.

  3. The Setup window will appear.

  4. Click on the New button to create a Poll group. XC Calc will automatically assign the next available poll group number. The first Poll group will be 1. The poll group number will increment automatically as you add more Poll groups. Right clicking on the Poll Group list and clicking on the New menu option will also create new poll groups.

  5. The poll group will automatically be "enabled". Enable so that this Poll group will be active and calculation result.

  6. Enter the equation. Please refer here for details on equations.

  7. Select the sensor from: Same Station or Multiple Stations. If Same Station is selected, then all sensors involved in the calculation are from one station, and the result is stored in a sensor in that station as well. You can use Similar Sites to apply the same calculation to many similar stations quickly. If Multiple Stations is selected, the sensors involved in the calculation can be from any stations in XConnect system. However, you cannot assign Similar Sites to this type of calculation. It must be specified one by one.

  8. Select a Filter File to reduce the number of station sensors listed below. Click Browse to select or create new filter files.

  9. Select an Output Station from the drop down combo box. If Same Station is selected above, then all the sensors involved in the calculations must be from that station.

  10. Select an Output Sensor from the drop down combo box. The calculation result is stored into this name.

  11. Assign Sensors to Variables. The list below has two columns. The left column lists all the variables that appear in the function. The right column matches the sensors to the variables on the left side. Click on it and all available sensors appear. Select or type the sensor name.

  12. If Same Station is select, you can select Similar Sites for the poll group. Change the order of your stations and sensors. Use the arrow buttons or drag and drop the node to the right side. If those stations have the same sensors, then the function will apply to them the same way as in the poll group.

  13. Click Save button to save the changes.


Poll group setup parameters

Valid variables are:

Any identifiers that start by a letter and follow by letters and/or numbers. Key words are reserved for operators and functions listed below.

Valid operators are:

+, -, *, /, OR, XOR, AND, MOD, SHR, SHL, >, >=, =, <=, <>, <

Valid functions are:

ARCTAN | Arc tangent of number and converted to radians.
ABS | Absolute value of number.
ASCII | For satellite systems, indicates that the decoding format used to decode that sensor was ASCII and not 6BIT.
COS | Converts number to radians and take cosine of number.
EXP | Exponential of number.
INT | Returns only integer portion of number.
LOG | Base 10 logarithm of number.
LN | Natural logarithm of number.
NOT | Takes logical opposite of value.
RND | Random number using truncated value as seed.
ROUND | Round number to nearest integer.
SIN | Converts number to radians and take sine of number.
SQRT | Takes square root of number.
TAN | Converts number to radians and takes tangent of number
TABLE(Name, X) | Indicates a lookup table will be used. TABLE(Name, X). Name represents the name of the table only, X represents the incoming sensor value. The path is represented by the Table Path parameter.
TRUNC | Truncates number to an integer.

Valid functions for database data storage options:

The functions below can be used only when the user selects database as the data storage options. These functions allow the user to retrieve coefficients/constants stored in the database record of the station or sensor.

DBTABLE(Name, X) | Indicates a lookup table will be used, however the rating table name will be retrieved from the database. Name represents the name of the sensor (i.e, STATION.STAGE) and X represents the incoming sensor value.
SHIFT(Name) | Retrieves the SHIFT value stored in the database for the sensor. Name represents then name of the sensor (i.e, STATION.STAGE).
OFFSET(Name) | Retrieves the OFFSET value stored in the database for the sensor. Name represents the name of the sensor (i.e, STATION.STAGE).
ELEV(Name) | Retrieves the ELEV value stored in the database for the sensor. Name represents the name of the sensor (i.e, STATION.STAGE).
STN_COEFF(Name, N) | Retrieves a COEFFICIENT value stored in the database for the station. Name represents the name of the station (i.e, STATION) and N represents the coefficient number (1-3).
SNS_COEFF(Name, N) | Retrieves a COEFFICIENT value stored in the database for the sensor. Name represents the name of the sensor (i.e, STATION.SENSOR) and N represents the coefficient number (1-5).
STN_GPN(Name, N) | Retrieves a Generic Number value stored in the database for the station. Name represents the name of the station (i.e, STATION) and N represents the Generic Number (1-2).
STN_GPN(Name, N) | Retrieves a Generic Number value stored in the database for the sensor. Name represents the name of the sensor (i.e, STATION.SENSOR) and N represents the Generic Number (1-2).

Poll Group Setup Parameters

In setting up XC Calc, poll groups must be defined. These poll groups are comprised of sites, sensors and a processing option based on some defined selection criteria (e.g. all sites with the rain gauge sensor, or all sites in a particular basin or latitude etc.). The data for sites and sensors belonging to a poll group are processed from the database at the same time. To set these parameters:

  1. Click the XC Calc icon on the desktop. The XC Calc application starts.

  2. From the Options menu, select Edit Setup Parameters or from the toolbar click on the [image] icon.

  3. The XC Calc Parameters window will appear.

From this window you can create and make changes to all poll groups. When you are finished, click the Save button to save changes.

All poll group parameters

  • Groups - List of current calculation poll groups. Select from the list to display the calculation parameters associated with the poll group.

  • New - Click this button to create/add a poll group. The first poll group will be 1. The poll group number will increment automatically as you add more Poll groups. Right clicking on the Poll Group list and clicking on the New menu option will also create new poll groups.

  • Delete - Click this button to delete the currently displayed poll group.

  • Delete All - Click this button to delete all poll groups. Use with caution!

  • Save - Click this button to save all parameters for currently displayed poll group.

  • Copy - Click this button to copy the parameters from one poll group to another.

  • Enable - This flag indicates the poll group is active and ready to be polled/processed. Poll groups can be created but left "inactive" until a later date.

  • Equation Name - This parameter indicates the type of calculation to apply to the sensor values. The equation can accept any numbers of the incoming sensor values. Those values are represented by variables that starting with a letter followed by letters and/or numbers. The equation is case-insensitive.

The equation grammar is outlined here.

Example 1:

A/100 + B

This example will divide the variable A by 100 then plus 100.

Example 2:

((X< .5)*(X*0)) + ((X >= .5)*(X*0+1))

This example will evaluate the incoming sensor value (X) in two parts. First, if the sensor value is less than 0.5, it will multiply it by 0. Second, if the sensor is greater than or equal to 0.5, it will multiply the value by 0 and add one. Essentially, this equation wants to return a sensor value of 0 or 1 if the value is below or above 0.5.

Note: When an equation has multiple parts, all parts of the equation will be checked. Make sure that no part of the equation will not result in an undefined/invalid value (such as a divide by 0).

Example 3:

Table(Guaratb,x/100)

This example uses a rating table. The keyword TABLE must be used. The first parameter is the table name. The table name is assumed to reside in the Table Path director specified in the XC Rtu or XC Decode setup window. Enter just the name without the path or extension. The second parameter is the sensor value. In this case, the senor value is divided by 100 before being passed in to the rating table.

  • Sensors from - Same Station or Multiple Stations. If Same Station is selected, then all sensors involved in the calculation are from one station, and the result is stored in a sensor in that station as well. You can use Similar Sites for quick applying the same calculation to many similar stations. If Multiple Stations is selected, the sensors involved in the calculation can be from any stations in XConnect system. However, you cannot assign Similar Sites to this type of calculation. It must be specified one by one.

  • Filter File - Filter files affect the list of sites displayed in the Sites list box. In a very large system (> 100 sites), browsing through such a long list of sites is difficult. Select a Filter File to reduce the list of site displayed to a specific list targeting the export purpose. Filter files can be created in XC DataView. Filter files are ASCII files with a .FLT extension containing statements used to filter/reduce the site list. The examples show the contents of different filter files.

Example 1:

LATITUDE < 42.866111

SENSOR = GH

ENABLED = Y

Example 2:

BASIN = REGION1

SENSOR = BATTERY

  • Output Station - The calculation result is stored into the select station. If Same Station is selected above, then all the sensors involved in the calculations must be from that station.

  • Output Sensor - The calculation result is stored into the select sensor.

  • Assign Sensors to Variables - The list below has several columns. The left column lists all the variables that appear in the function. The right column matches the sensors to the variables on the left side. Click on it and all available sensors appear. Select or type the sensor name.

    • If Same Station is selected, you can select Similar Sites for the poll group. Change the order of your stations and sensors. Use the arrow buttons or drag and drop the node to the right side. If those stations have the same sensors, then the function will apply to them the same way as in the poll group.

Similar Sites - List of stations that have the similar sensor layout and subject to the same type of calculations in this poll group.

    • If Multiple Station is selected, the third column has a radio box let you specify the sensor triggering the calculation. Because all data are coming from different stations, those values are coming in different order. It is necessary to specify the triggering sensor in order to make the calculation. Click the ... button to pop up sensor selection window.


Setup Example 1 - Water Flow

In a gate control system, we want to calculate the water flow based on gate position, upstream and downstream water level.

  1. Click New to add a new group.

  2. Enter the equation, e.g. GPOS * 8.0 * 0.61* SQRT(64.36 * (USLEV- DSLEV)) where GPOS is gate position; USLEV is upstream water level; DSLEV is downstream water level.

  3. Assume all three sensors come from one station. Select Same Station.

  4. Enter the Output Station, e.g. CHECK1

  5. Enter the Output Sensor, e.g. FLOW. Make sure FLOW is defined in XCDesktop.

  6. In Assign Sensors to Variables, enter the sensor names from the drop-down combo box.

  7. In this example, there are 5 more stations have the same sensors and calculations. Select them from Similar Sites. They will share the same equation and sensor mapping.

  8. Click Save to save the settings.

Copyright © 2003 Sutron Corporation. All rights reserved.


Setup Example 2 - Water Flow

In example 1, we have assumed upstream water level sensor is in the same station as downstream water level sensor. This may not be true if those two sensors are separated by great distance. In such case, select Sensors From Multiple Stations.

  1. Click New to add a new group.

  2. Enter the equation, e.g. GPOS * 8.0 * 0.61* SQRT(64.36 * (USLEV- DSLEV)) where GPOS is gate position; USLEV is upstream water level; DSLEV is downstream water level.

  3. Select Mulitple Station.

  4. Enter the Output Station, e.g. CHECK2

  5. Enter the Output Sensor, e.g. FLOW. Make sure FLOW is defined in XCDesktop.

  6. In Assign Sensors to Variables, enter the sensor names from the drop-down combo box. The radio button next to USLEV means CHECK1.USLEV is the trigger for this calculation group. When this sensor has a new value coming in, the FLOW will be updated.

  7. Click Save to save the settings.


Setup Example 3 - QNH

QNH is pressure reduced to mean sea level using atmospheric layering defined in the ICAO standard atmosphere. This is calculated from the barometer reading, taking into account the difference in the elevation.

  1. Click New to add a new group.

  2. Enter the equation, e.g. P*EXP(9.81*100/(287*(T+273-0.0065*100/2))) where P is the barometer reading; T is the temperature in Celsius; 100 is the station elevation in meters.

  3. Select Single Station.

  4. Enter the Output Station, e.g. ANTIGUA

  5. Enter the Output Sensor, e.g. QNH. Make sure QNH is defined in XCDesktop.

  6. In Assign Sensors to Variables, enter the sensor names from the drop-down combo box. BARO is assigned to P; AT is assigned to T.

  7. Click Save to save the settings.


Setup Example 4 - Rating Table

This example uses a rating table. The keyword TABLE must be used. The first parameter is the table name. The table name is assumed to reside in the Table Path director specified in the XC Rtu or XC Decode setup window. Enter just the name without the path or extension. The second parameter is the sensor value. Make sure the rating table file has extension TBL.

  1. Click New to add a new group.

  2. Enter the equation, e.g. TABLE(CHK6, GTPOS) where CHK6 is the rating table; GTPOS is the gate position.

  3. Select Single Station.

  4. Enter the Output Station, e.g. CHECK6

  5. Enter the Output Sensor, e.g. FLOW. Make sure FLOW is defined in XCDesktop.

  6. In Assign Sensors to Variables, enter the sensor names from the drop-down combo box.

  7. Click Save to save the settings.


Messages in the status window

XC Calc has loaded the configuration information from its INI file.

XC Calc is requesting the station and sensor information from XC Setup.

XC Calc received a Refresh command from XC Setup. XC Calc will disconnect from current servers and then reconnect to the XConnect servers.

XC Calc received a Shutdown command from XC Setup. XC Calc will prepare to shutdown also.

XC Calc has initialized properly, connected to XConnect servers and is waiting for data.

XC Calc received a Shutdown command from XC Rtu. XC Calc will prepare to disconnect from XC Rtu as a data source.

XC Calc received a Shutdown command from XC Decode. XC Calc will prepare to disconnect from XC Decode as a data source.

No equation was entered on the Setup window.

Invalid equation. No variables (A..Z) are in the equation.

Neither the Same Station or Multiple Station option was selected on the Setup window for the calculation group. Please select one.

An output station was not selected on the Setup window for the calculation group.

An output sensor was not selected on the Setup window for the calculation group.

Select a sensor assigned to the equation variable on the Setup window.

When performing a calculation with sensors from different stations, a sensor must be selected as the trigger to initiate the calculation. Select the sensor last received to be the trigger.

XC Calc calculation thread has started. XC Calc is ready and waiting for data from XC Rtu or XC Decode.

XC Calc calculation thread has stopped. No calculations will be performed.

XC Calc is terminating or a ReInitialize has been received. All calculations will be stopped.

A ReInitialize has been received. All calculations will be stopped and re-started.

Messages in the status window

Below are the status messages that XC Calc will display in the status window as it display data from either XC Rtu or XC Decode:

  • Startup parameters loaded.

  • Retrieving setup parameters from XC Setup...

  • Refresh command received.

  • Shutdown command received.

  • Ready...

  • XC Rtu shutdown command received.

  • XC Decode shutdown command received.

  • Equation empty. Please enter a valid equation.

  • Please enter a valid function.

  • Please select sensor from single station or multiple stations.

  • Please select an output station.

  • Please select an output sensor.

  • Please assign sensors to variables.

  • Please select a variable that will trigger the calculation.

  • Calculation thread started.

  • Calculation thread stopped.

  • Calculation thread stopping... All unprocessed messages will be lost.

  • Setup has been changed. Restarting the calculation thread.


Logging status messages

The purpose of the Log Status Messages is for troubleshooting. Logging all messages, will provide Sutron customer support a historical log of all events to help troubleshoot any problems. To log all status messages:

  1. Click the XC Calc icon on the desktop. The XC Calc application starts minimized.

  2. From the Options menu, select Log Status Messages or from the toolbar click on the [image] icon. The log file XCCalc.log will be created in the same directory as XCCalc.exe.

Note: In XC Calc configure file XCCalc.XFG, LogDetail in section Calc controls the detail level for status messages. The valid number for LogDetail is from 0 to 9. If it is set to 0, it generates only the most important messages and errors; if it is set to 9, all trace messages will be turned on. For normal troubleshooting, a value of 6 is usually appropriate.


Reinitializing parameters

XC Calc gets the configuration data it needs from the XC Setup program. Since most of this information is requested at application startup, there needs to be a mechanism for propagating changes that are made to the setup after XC Calc is already running. This mechanism is provided via the Reinitialize [image] function which can be found in XC Alarm on the toolbar or under the FILE menu. Clicking the Reinitialize [image] button causes XC Alarm to flush the current setup information from its buffer, request new setup information from XC Setup and most importantly, re-connects to the XC Rtu or XC Decode.


Equation Grammar

A short description on equation grammar is outlined here.

Expression

-> SimpleExpression [RelOp SimpleExpression]...

SimpleExpression

-> ['+' | '-'] Term [AddOp Term]...

Term

-> Factor [MulOp Factor]...

Factor

-> Function ['(' ExprList ')']

-> Number

-> Variable

-> '(' Expression ')'

-> NOT Factor

RelOp

-> '>'

-> '<'

-> '<='

-> '>='

-> '<>'

AddOp

-> '+'

-> '-'

-> OR

-> XOR

MulOp

-> '*'

-> '/'

-> DIV

-> MOD

-> AND

-> SHL

-> SHR

Function

-> ARCTAN

-> ABS

-> ASCII

-> COS

-> EXP

-> INT

-> LOG

-> LN

-> NOT

-> RND

-> ROUND

-> SIN

-> SQRT

-> TAN

-> TABLE

-> TRUNC

Variable

-> Letter [Letter|Digit...]


Rating/Lookup Tables

A rating/lookup table is an ASCII comma separated file with an extension of ".TBL" which should be stored in the directory specified by Table Path in either the XC Rtu setup window or the XC Decode setup window. The file can contain any number of comment lines which must begin with a semi-colon at the beginning of the line. The first non-comment in the file must contain the table type. Following is a list of valid table types:

  • LINEAR - Linear X axis, and Linear Y axis lookup table

  • SEMILOGX - Logarithmic X axis, and Linear Y axis lookup table

  • SEMILOGY - Linear X axis, and Logarithmic Y axis lookup table

  • LOGLOG - Logarithmic X axis, and Logarithmic Y axis lookup table

  • GSLINEAR - USGS Standard Rating table using Linear X and Y axis.

  • GSLOGLOG - USGS Standard Rating table using Logarithmic X and Y axis.

Following the table type is the data points of the table. All data points are assumed to be in user units (for instance X axis in FT, and Y axis in FLOW). LINEAR, SEMILOGX, SEMILOGY, and LOGLOG tables consists of rows of X,Y data points. GSLINEAR and GSLOGLOG consists of rows of X, Y, OFFSET, SHIFT data points. Each data point must be on a separate line. The amount of data contained in a table is only limited by the amount of free memory in the computer as the all accessed tables are stored in memory. Use an ASCII edit such as Notepad to create the rating table. Microsoft Word is NOT an ASCII editor, it is a word processing application that will embed formatting characters. If using Microsoft Word, save files on as Text Only.

Example 1

LINEAR

;VOLTS,Degrees F

0.0,0.0

1.0,20.0

2.0,40.0

3.0,60.0

4.0,80.0

5.0,100.0

Example 2

GSLOGLOG

;STAGE (FT), FLOW (CFS), OFFSET, SHIFT

0.00,0.000,1,0

1.07,0.000,1,0

1.12,0.050,1,0

1.15,0.090,1,0

1.18,0.140,1,0

1.22,0.210,1,0

1.27,0.320,1,0

1.37,0.670,1,0

1.45,1.080,1,0

1.59,2.160,1,0

1.66,2.850,1,0

1.72,3.600,1,0

1.78,4.450,1,0

1.90,6.300,1,0


Error messages

Troubleshooting steps:

A COM interface connection is made by each XConnect application to XC Setup. This allows the applications to retrieve and send configuration parameters related to XC Calc.

Potential reasons for error:

  • XC Setup is not running.

Close current application and restart. XC Setup should start automatically.

  • XC Setup does not start automatically with XConnect application.

Close current application. Start XC Setup manually from Start Menu. Then re-start XConnect application.

If error still persists, reboot computer.

Troubleshooting steps:

Potential reasons for error:

  • XC Setup is not running.

Ensure that XC Setup is shown on the Windows taskbar.

  • COM connection to XC Setup is corrupted. Close current application and re-start.

Troubleshooting steps:

Ensure that:

  • Current XConnect application is part of the purchased XConnect license.

Refer to the original purchase order.

Troubleshooting steps:

Potential reasons for error:

  • Current XConnect application is not valid for use with existing XConnect license.

Call Sutron Sales to upgrade XConnect license.

Troubleshooting steps:

Potential reasons for error:

  • Detail level is not a valid number.

Ensure the LogDetail setting in the XCCalc.XFG file is a number from 0-10.

Troubleshooting steps:

Potential reasons for error:

  • Current calculation generated an exception error.

Increase the detail level to trace calculation steps. Review/verify equation.

Troubleshooting steps:

Potential reasons for error:

  • Variable is not found in Assigned Sensors to Variables list. All variables (A..Z) in an equation will appear in the Assigned Sensors list so the user can map a sensor to variable.

In this rare case, a variable in the equation does not appear in the list.

This will only happen if the user edits the XCCalc.XFG file manually. We do not advise this method of editing. Please use the XC Calc Setup window.

Troubleshooting steps:

Potential reasons for error:

  • Sensor value is not in the data buffer/cache to complete equation/calculation.

A sensor assigned to a variable of an equation has not been received for that time stamp or has not been received at all.

Troubleshooting steps:

Potential reasons for error:

  • For calculations where all sensors are from one station, the sensor did not have the same time stamp as all the other sensor variables.

Verify the RTU setup has not changed where the sensor is not enabled and not being transmitted.

Verify no setup changes in XC Desktop have been made if the sensor is calculated in XC Rtu.

Troubleshooting steps:

Potential reasons for error:

  • Failure to parse station.sensor in to a station and sensor name.

Ensure no spaces or other characters are in the station.sensor name. This error should rarely occur. It may be a result of faulty edits to the XCCalc.XFG.

Troubleshooting steps:

Potential reasons for error:

  • Invalid characters in sensor names.

Ensure characters in sensor names are alphanumeric. This error should rarely occur. It may be a result of faulty edits to the XCCalc.XFG.

Troubleshooting steps:

Potential reasons for error:

  • Syntax error in equation.

Review syntax. Ensure there are no missing parentheses or incorrectly typed functions.

Troubleshooting steps:

Potential reasons for error:

  • Syntax error in table function.

Review syntax. Ensure there are no missing parentheses, missing parameters or incorrectly typed functions.

Troubleshooting steps:

Potential reasons for error:

  • Syntax error in equation.

Ensure there are no missing parentheses.

Troubleshooting steps:

Potential reasons for error:

  • Current XConnect application is not valid for use with existing XConnect license.

Call Sutron Sales to upgrade XConnect license.

Troubleshooting steps:

Potential reasons for error:

  • Current XConnect application is not valid for use with existing XConnect license.

Call Sutron Sales to upgrade XConnect license.

Troubleshooting steps:

Potential reasons for error:

  • Current XConnect application is not valid for use with existing XConnect license.

Call Sutron Sales to upgrade XConnect license.

Troubleshooting steps:

Potential reasons for error:

  • Current XConnect application is not valid for use with existing XConnect license.

Call Sutron Sales to upgrade XConnect license.

Troubleshooting steps:

Potential reasons for error:

  • Current XConnect application is not valid for use with existing XConnect license.

Call Sutron Sales to upgrade XConnect license.

Troubleshooting steps:

Potential reasons for error:

  • Current XConnect application is not valid for use with existing XConnect license.

Call Sutron Sales to upgrade XConnect license.

Troubleshooting steps:

Potential reasons for error:

  • Current XConnect application is not valid for use with existing XConnect license.

Call Sutron Sales to upgrade XConnect license.

Troubleshooting steps:

The data storage option selection is invalid with the XConnect installation. Potential reasons for error:

  • XConnect Lite was purchased. The database data storage option is an invalid option for XConnect Lite.

Troubleshooting steps:

Potential reasons for error:

  • XC Setup is not running.

Ensure that XC Setup is shown on the Windows taskbar.

  • COM connection to XC Setup is corrupted. Close current application and re-start.

Troubleshooting steps:

Potential reasons for error:

  • XC Setup is not running.

Ensure that XC Setup is shown on the Windows taskbar.

  • COM connection to XC Setup is corrupted. Close current application and re-start.

Troubleshooting steps:

Potential reasons for error:

  • For Excel/ASCII log file storage option, an error in the file directory will prevent the creation of the data storage option.

Using Windows Explorer, ensure the file directory exists and can be viewed.

  • For PcBase2 binary file and database storage option, a memory error will prevent the creation of the data storage option.

Close all unnecessary applications and XConnect modules and re-start XConnect. If error continues after re-start of XConnect, re-boot computer.

Troubleshooting steps:

For the PcBase2 binary file data storage option, XC Decode and XC Desktop must read the header of every binary file in the XConnect system.

Potential reasons for error:

  • Binary file may be corrupt.

Go to XC Desktop and the Data Storage setup window. Try to select the binary file.

Recreate data file in XC Desktop.

Troubleshooting steps:

Potential reasons for error:

  • PcBase2 binary file may be corrupt.

Go to XC Desktop and the Data Storage setup window. Try to select the binary file.

  • Insufficient disk space to store data.

Open My Computer. Right click on the properties of the drive (i.e., C:) that XConnect is installed. Check disk space used.

Troubleshooting steps:

Potential reasons for error:

  • PcBase2 binary file may be corrupt.

Go to XC Desktop and the Data Storage setup window. Try to select the binary file.

  • Insufficient disk space to store data.

Open My Computer. Right click on the properties of the drive that XConnect is installed. Check disk space used.

Troubleshooting steps:

For the database storage option, XC Calc could not store data into the XC_DATA1 data table.

Potential reasons for error:

  • Ensure the Data Sources (ODBC) is configured correctly and the database has sufficient data space to store data.

Troubleshooting steps:

For the database storage option and the current XConnect database schema, this error should never occur.

If the XConnect database schema expands to include multiple XC_DATA tables (i.e, XC_DATA1, XC_DATA2...etc), the sensor records in XC_SITESSENSORS will contain which data table the specific sensor is stored.

Error Messages

Potential error messages generated by XC Calc are:

Error 4: An instance of the "XCSetup.Applications" OLE Automation class could not be created. Is XC Setup running?

Error 6: An error occurred while retrieving parameters from XC Setup.

Error 8: Invalid License Key. Please verify XConnect is properly installed.

Error 9: Invalid License Key. Exiting now...

Error 1600: ...

Error 1601: Value is not a number - .

Error 1602: Error in computation - xxx - StationID: station TimeTag: 00/00/0000 00:00:00 Poll Group: x.

Error 1603: Variable not found in poll group x.

Error 1604: Variable not found or never updated - PollGroup: x StationID: station SensorName: sensor.

Error 1605: Variable not updated - PollGroup: x StatonID: station SensorName: sensor TimeTag: 00/00/0000 00:00:00.

Error 1606: Variables can not be mapped to station.sensor - PollGroup: x

Error 1607: Invalid variable names in the function.

Error 1608: Equation syntax error.

Error 1609: Table syntax error.

Error 1610: Syntax error - ")" expected.

Error 1611: Last value lookup failed.

Error 1612: Divide by Zero.

Error 1613: Unknown Refresh Exception.

Error 1614: Unable to connect to XC Decode Interface.

Error 1615: Unable to connect to XC Rtu Interface.

Error 1616: Data storage option must be database.

Error 1617: Unable to connect to database - database.

Potential error messages generated by XC Calc during data storage are:

Error 600: Data storage option invalid with XConnect installation.

Error 601: Unable to retrieve Data Storage Setup parameters.

Error 602: Unable to update Data Storage Setup parameters.

Error 603: Unable to create data store option.

Error 604: Unable to read header from file xxx.

Error 607: Unable to write data for file xxx.

Error 609: Unable to insert data into xxx.dat for station.sensor for 00/00/0000 00:00:00.

Error 619: Unable to insert/update xc_data data value: station.sensor for 00/00/0000 00:00:00 is xxx.

Error 620: Unable to locate station.sensor in database.


Troubleshooting Tips

XC Calc's role is to make calculation while new values are coming in. Those values are gathered and decoded by XCRtu and/or XCDecode. If those two modules are not running, XC Calc will not be able to make any calculations. And because XC Calc has to store the data into database storage selected in XCDesktop, it must has a valid connection to database.

Problem: No values are passed to XC Calc.

First make sure XC Setup is running and has a valid setup. Second, make sure the data storage is configure to database and a valid data source, user name and password are entered. Third make sure XC Rtu or XC Decode is running and has values coming in. Then press Refresh Params to reconnect to those applications.

Problem: XC Calc are not making any calculations.

Open the setup window and check the poll group settings. If the poll groups are enabled, check the equation and make sure all variables have valid assignments.

In order to make the calculation, all variables in the equation must have a valid value. Please check the values using XC Dataview.

Problem: Sensor data is not being stored in data storage option.

In XC Desktop - Data Storage Setup window, verify all the setup parameters are correct for the selected storage option.

For XConnect database, verify the Data Source selection is correct and the ODBC settings are correct.


Menu Bar

The Menu Bar

The Menu Bar provides access to the following menus:

File

  • Refresh [image] -- reloads the latest setup information from XC Setup and re-connects to local XC Rtu and/or XC Decode.

  • Exit [image] -- terminate the application.

Options

  • Edit Setup Parameters [image] -- change or edit setup parameters, such as create new groups, change functions, select outputs and Sites to be processed.

  • Clear Status Messages [image] -- clear the status message window.

  • Log Messages [image] -- write all message in the status message into XCCalc.log in the same directory of XCCalc.exe.

Help

  • XC Calc Help [image] -- access this help system an defaults to Index tab.

  • XC Calc Contents -- access this help system an defaults to Contents

  • About -- get version information for this application.


Status panel

The Status Panel

The status area displays the program status and hints on the status bar.


Status Window

The Status Window

The Status window gives a list of real-time display events performed by the XC Calc program.

This list of status messages is in time order with each entry stamped with the date and time. Newest messages will appear at the top. Scroll bars will appear as needed to allow an operator to view parts of the display that may not fit in the window.


Toolbar

The Toolbar

The toolbar area allows you to quickly access various XC Calc functions.

The following tools are provided:

Reload the latest setup information from XC Setup and re-connects to local XC Rtu and/or XC Decode.

Edit graph display settings.

Clear all messages in the status window.

Log all messages into log file. The default log file name is XCCalc.log in the same directory as the XCCalc.exe.

Show status messages panel.

Open the on-line help (this document).